/*******************************************************************************
 * Copyright (c) 2013 Olivier Langella <Olivier.Langella@moulon.inra.fr>,
 * Benoit Valot <Benoit.Valot@moulon.inra.fr> 
 * 
 * This file is part of XTandemPipeline.
 * 
 *     XTandemPipeline is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     XTandemPipeline is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with XTandemPipeline.  If not, see <http://www.gnu.org/licenses/>.
 * 
 ******************************************************************************/
package fr.inra.pappso.xtandempipeline.class_msms.XtandemFiles;

import java.io.File;

import fr.inra.pappso.xtandempipeline.sax_parse.HandlerXtModelFile;
import fr.inra.pappso.xtandempipeline.sax_parse.parse_file;
import fr.inra.pappso.xtandempipeline.sax_parse.xtandem_params;

public class XtandemModelFile {

	private File xtandemModelFile;

	public XtandemModelFile(File xtandemModelFile) {
		this.xtandemModelFile = xtandemModelFile;
	}

	public String getName() {
		return xtandemModelFile.getName();
	}

	public boolean exists() {
		return xtandemModelFile.exists();
	}

	public boolean delete() {
		return xtandemModelFile.delete();
	}

	public String getAbsolutePath() {
		return xtandemModelFile.getAbsolutePath();
	}

	public void readParamsFromFile(xtandem_params xtandem_params)
			throws Exception {
		new parse_file(new HandlerXtModelFile(xtandem_params), xtandemModelFile);
	}

}
