package fr.inra.pappso.xtandempipeline.grouping;

import java.util.HashMap;

import org.apache.log4j.Logger;

public class HashProteinSet extends HashKey4GroupsSet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4336539016965494789L;

	/**
	 * 
	 */
	private static final Logger logger = Logger.getLogger(HashProteinSet.class);

	//Accession is String key for ensure unique protein!
	private HashMap<String, HashProtein> mapHashProtein = new HashMap<String, HashProtein>(
			0);

	public HashProteinSet() {
		// logger.debug("HashPeptideSet begin");
	}

	public HashProtein getInstance(String accession) {
		
		HashProtein temp = this.mapHashProtein.get(accession);
		if(temp == null){
			temp = new HashProtein(accession);
			this.mapHashProtein.put(accession, temp);
			boolean test = this.add(temp);
			if(!test){
				logger.error("HashProtein COLLISION, must never appear");
			}
			return(temp);
		}else{
			// find the existing instance of the same protein :
			return(temp);
		}
	}

	@Override
	public void clear() {
	 	mapHashProtein = new HashMap<String, HashProtein>(0);
		super.clear();
	}

}
