package fr.inra.pappso.xtandempipeline.grouping;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.grouping.interfaces.GrpMsSample;

public class SubGroup extends HashSampleScanSet {
	/**
	 *
	 */
	private static final long serialVersionUID = 3563300355147274825L;
	/**
	 *
	 */
	private static final Logger logger = Logger.getLogger(SubGroup.class);

	// private HashPeptideSet peptideSet= new HashPeptideSet();
	private HashSet<HashSampleScanSetProt> peptideSetProtSet = new HashSet<HashSampleScanSetProt>();

	private Integer number = null;

	public SubGroup(HashSampleScanSetProt hashPeptideSetProt) {
		peptideSetProtSet.add(hashPeptideSetProt);
		HashSampleScanSet incoming = hashPeptideSetProt;
		this.addAll(incoming);
	}

	@Override
	public String toString() {
		String subGroupStr = new String();
		for (HashSampleScanSetProt setProt : peptideSetProtSet) {
			subGroupStr = subGroupStr + setProt.toString();
		}
		return subGroupStr;

	}

	@Override
	public boolean equals(Object toCompar) {
		if (this == toCompar) {
			return (true);
		}
		return (false);
	}

	// @Override
	public boolean addHashSampleScanSetProt(HashSampleScanSetProt incomingProt) {

		HashSampleScanSet incoming = incomingProt;

		if (this.size() == incoming.size()) {
			if (this.containsAll(incoming)) {
				peptideSetProtSet.add(incomingProt);
				return true;
			}
			return false;
		}
		if (this.containsAll(incoming)) {
			return true;
		}
		if (incoming.containsAll(this)) {
			peptideSetProtSet.clear();
			peptideSetProtSet.add(incomingProt);
			this.addAll(incoming);
			return true;
		}
		return false;
	}

	public HashKey4GroupsSet getHashKey4GroupsSet() throws Exception {
		HashKey4GroupsSet hashPeptideSet = new HashKey4GroupsSet();
		for (HashSampleScanSetProt sampleScanProt : peptideSetProtSet) {
			hashPeptideSet.addAll(sampleScanProt.getHashKey4GroupsSet());
		}

		return hashPeptideSet;
	}

	protected void setNumber(int i) {
		number = i;
	}

	public Integer getNumber() {
		return number;
	}

	public HashSet<HashSampleScanSetProt> getHashSampleScanSetProtSet() {
		return this.peptideSetProtSet;
	}

	public ArrayList<HashSampleScanSetProt> getHashSampleScanSetProtList() {
		ArrayList<HashSampleScanSetProt> peptideSetProtList = new ArrayList<HashSampleScanSetProt>(
				peptideSetProtSet);
		Collections.sort(peptideSetProtList);
		return peptideSetProtList;
	}

	public void loggerDebug() {
		super.loggerDebug();
	}

	public int getNumberOfSpectraInGrpMsSample(GrpMsSample msSample) {
		// warning : this is the same function as getTotalHashSampleScantoMsRun in HashSampleScanSetProt
		// this needs some refactoring
		int count = 0;
		for (HashSampleScan hash : this) {
			if (hash.getGrpMsSample().isIdenticalTo(msSample)) {
				count++;
			}
		}
		return (count);
	}

	/**
	 * get number of unique peptide sequence by MS sample
	 * 
	 * @param sample
	 * @return
	 * @throws MSMSException
	 */
	public int getNumberOfUniquePeptideByGrpMsSample(GrpMsSample sample)
			throws MSMSException {
		HashSet<String> sequences = new HashSet<String>();
		for (HashSampleScan hash : this) {
			if (hash.getGrpMsSample().isIdenticalTo(sample)) {

				sequences.add(this.getHashSampleScanSetProtList().get(0)
						.getGrpProtMatch().getBestPeptideToHashSampleScan(hash)
						.getSequence());

			}
		}
		return (sequences.size());
	}

}
