package fr.inra.pappso.xtandempipeline.output;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.Vector;

import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;

//import com.sun.xml.internal.txw2.output.IndentingXMLStreamWriter;
import javax.xml.stream.XMLStreamWriter;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.xtandem_param;

public class XtandemParamsOutput {
	private static final Logger logger = Logger.getLogger(XtandemParamsOutput.class);

	XMLStreamWriter writer;
	OutputStream outputStream;

	public XtandemParamsOutput(FileOutputStream fileOutputStream,
			Vector<xtandem_param> params) throws MSMSException {

		try {

			this.outputStream = fileOutputStream;
			XMLOutputFactory factory = XMLOutputFactory.newInstance();
			// OutputStreamWriter noIndentOutput = new OutputStreamWriter(
			// outputStream, "UTF8");
			// XMLStreamWriter writer =
			// factory.createXMLStreamWriter(noIndentOutput);
			OutputStreamWriter output = new OutputStreamWriter(outputStream,
					"UTF8");

			writer = new IndentingXMLStreamWriter(
					factory.createXMLStreamWriter(output));
			writer.writeStartDocument("UTF-8", "1.0");

			writer.writeStartElement("bioml");
			// out.write("<bioml label=\"example api document\">" + "\n");
			writer.writeAttribute("label", "example api document");

			for (xtandem_param param : params) {
				this.write(param);
				// out.write(param.write_to_xml() + "\n");
			}
			writer.writeEndElement();
			writer.writeEndDocument();
			writer.close();
			fileOutputStream.close();

			logger.debug("No errors writing X!Tandem parameter file. All seems OK!");
		} catch (Exception e) {
			try {
				outputStream.write(e.getMessage().toString().getBytes());
			} catch (IOException e1) {
				logger.debug("ERROR : " + e.getMessage(), e);
			}
			// throw new ProticPortException ("ERROR writing mzXml "+
			// e.getMessage());
			logger.debug(
					"ERROR writing X!Tandem parameter file : " + e.getMessage(),
					e);
		}
	}

	private void write(xtandem_param param) throws XMLStreamException {
		writer.writeStartElement("note");
		writer.writeAttribute("type", "input");
		writer.writeAttribute("label", param.xmlvalue());
		writer.writeCharacters(param.getValue());
		writer.writeEndElement();
	}

}
