/*******************************************************************************
 * Copyright (c) 2015 Olivier Langella <Olivier.Langella@moulon.inra.fr>
 *
 * This file is part of XTandemPipeline.
 *
 *     XTandemPipeline is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     XTandemPipeline is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with XTandemPipeline.  If not, see <http://www.gnu.org/licenses/>.
 *
 ******************************************************************************/

package fr.inra.pappso.xtandempipeline.sax_parse;

import fr.inra.pappso.xtandempipeline.class_msms.*;
import fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile.IdentificationDataSource;

public class HandlerPepXmlResultPhosphoFile extends HandlerPepXmlResultFile {

	public HandlerPepXmlResultPhosphoFile(Identification L,
			IdentificationDataSource S) {
		super(L, S);
	}

	@Override
	public void endElementsearch_hit(String nameSpaceUri, String data) {
		if (this.currentPeptide.getGrpPhosphoModifs().size() > 0) {
			identification.add_peptide(this.currentPeptide);
			currentMatch.add_peptide_match(currentPeptide);
		}
	}

}
