package fr.inra.pappso.xtandempipeline.thread;

import java.io.*;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;

public class base_shell {
	private static final Logger logger = Logger.getLogger(base_shell.class);

	private ProcessBuilder build;

	private String application;

	private String[] commande;

	private StringBuilder stdout;

	private Exception error;

	private Process process_run;

	private monthread t;

	public base_shell() {
		application = "";
		stdout = new StringBuilder();
		error = null;
	}

	public void set_commande(String[] commande) {
		this.commande = commande;
		application = commande[0];
	}

	public String[] get_commande() {
		return commande;
	}

	public String get_Stdout() {
		return stdout.toString();
	}

	public void start_process() throws Exception {
		if (application.equals(""))
			throw new MSMSException("No application specified");
		File appFile = new File(application);
		if (!appFile.exists()) {
			throw new MSMSException("no command file named : \n"
					+ appFile.getAbsolutePath());
		}
		if (!appFile.canExecute()) {
			throw new MSMSException("unable to execute command : \n"
					+ appFile.getAbsolutePath());
		}
		build = new ProcessBuilder(commande);
		build.redirectErrorStream(true);
		process_run = build.start();
		t = new monthread();
		t.setDaemon(true);
		t.start();
	}

	public void processing(String mess) {
		// analyse du flux de sortie de l'application
		logger.debug(mess);
	}

	public Exception get_error() {
		// gérer les erreurs
		return (error);
	}

	protected void set_error(Exception ioe) {
		// gérer les erreurs
		this.error = ioe;
	}

	public boolean status() {
		return (t.isAlive());
	}

	public void stop_process() {
		// Arret de l'application
		process_run.destroy();
	}

	public void test_result() {

	}

	class monthread extends Thread {
		public void run() {
			try {
				BufferedReader reader = new BufferedReader(
						new InputStreamReader(process_run.getInputStream()));
				int line = 0;
				try {
					line = reader.read();
					while (line != -1) {
						// processing(line);
						stdout.append((char) line);
						// System.out.print((char)line);
						line = reader.read();
					}
				} finally {
					reader.close();
					test_result();
				}
			} catch (IOException ioe) {
				set_error(ioe);
			}
		}
	}

}
