package fr.inra.pappso.xtandempipeline.ui.swt;

import java.awt.Desktop;
import java.io.File;
import java.net.URI;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;



import fr.inra.pappso.xtandempipeline.XtandemPipelineSession;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.config;

public class Path_configuration {

	protected Shell shell;
	private config conf;

	public Path_configuration(Main_Windows controlleur) {
		this.conf = XtandemPipelineSession.getInstance().getConfig();
		shell = new Shell(controlleur.getDisplay(), SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		shell.setImages(controlleur.getImages());
		shell.setText("Path configuration");

		this.set_interface();

		shell.pack();
		shell.open();
	}

	private void set_interface() {
		GridLayout layout = new GridLayout(1, false);
		layout.marginLeft = layout.marginTop = layout.marginRight = layout.marginBottom = 10;
		layout.verticalSpacing = 10;
		shell.setLayout(layout);

		Group set_xtandem = new Group(shell, SWT.SHADOW_IN);
		set_xtandem.setText("Define X!Tandem software installation");
		set_xtandem.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		set_xtandem.setLayout(new GridLayout(3, false));

		Text xtantem_path = new Text(set_xtandem, SWT.SINGLE | SWT.READ_ONLY);
		xtantem_path.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		if (conf.getXtandem_software_installed())
			xtantem_path.setText(conf.getXtandem_link().getAbsolutePath());
		else
			xtantem_path.setText("Not installed");
		Button set = new Button(set_xtandem, SWT.PUSH);
		set.setText("Set");
		set.setData("text", xtantem_path);
		set.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Path_configuration.this.set_xtandem_software((Text) e.widget
						.getData("text"));
			}
		});
		Button download = new Button(set_xtandem, SWT.PUSH);
		download.setText("Download");
		download.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Path_configuration.this.download_xtandem_software();
			}
		});

		Group path = new Group(shell, SWT.SHADOW_IN);
		path.setText("Define prefered folder to");
		path.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		path.setLayout(new GridLayout(3, false));

		Label l = new Label(path, SWT.RIGHT);
		l.setText("X!Tandem presets : ");
		Text t = new Text(path, SWT.SINGLE | SWT.READ_ONLY);
		t.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		t.setText(conf.getXtandemModelsDirectory().getPath());
		set = new Button(path, SWT.PUSH);
		set.setText("Set");
		set.setData("text", t);
		set.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String out = Path_configuration.this
						.get_folder_to("X!tandem preset");
				if (out != null) {
					conf.setXtandem_model(new File(out));
					((Text) e.widget.getData("text")).setText(conf
							.getXtandemModelsDirectory().getPath());
				}
			}
		});

		l = new Label(path, SWT.RIGHT);
		l.setText("Peaklist data : ");
		t = new Text(path, SWT.SINGLE | SWT.READ_ONLY);
		t.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		t.setText(conf.getRaw_data().getPath());
		set = new Button(path, SWT.PUSH);
		set.setText("Set");
		set.setData("text", t);
		set.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String out = Path_configuration.this
						.get_folder_to("peaklist data");
				if (out != null) {
					conf.setRaw_data(new File(out));
					((Text) e.widget.getData("text")).setText(conf
							.getRaw_data().getPath());
				}
			}
		});

		l = new Label(path, SWT.RIGHT);
		l.setText("Proteins Databases : ");
		t = new Text(path, SWT.SINGLE | SWT.READ_ONLY);
		t.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		t.setText(conf.getProtein_database().getPath());
		set = new Button(path, SWT.PUSH);
		set.setText("Set");
		set.setData("text", t);
		set.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String out = Path_configuration.this
						.get_folder_to("protein database");
				if (out != null) {
					conf.setProtein_database(new File(out));
					((Text) e.widget.getData("text")).setText(conf
							.getProtein_database().getPath());
				}
			}
		});

		l = new Label(path, SWT.RIGHT);
		l.setText("Results : ");
		t = new Text(path, SWT.SINGLE | SWT.READ_ONLY);
		t.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		t.setText(conf.getXmlresult().getPath());
		set = new Button(path, SWT.PUSH);
		set.setText("Set");
		set.setData("text", t);
		set.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				String out = Path_configuration.this.get_folder_to("results");
				if (out != null) {
					conf.setXmlresult(new File(out));
					((Text) e.widget.getData("text")).setText(conf
							.getXmlresult().getPath());
				}
			}
		});

		Label separator = new Label(shell, SWT.SEPARATOR | SWT.HORIZONTAL);
		separator.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

		Button next = new Button(shell, SWT.PUSH);
		next.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END));
		next.setText("Close");
		next.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Path_configuration.this.save_configuration_to_disque();
				Path_configuration.this.shell.dispose();
			}
		});
	}

	protected void set_xtandem_software(Text t) {
		FileDialog dlg = new FileDialog(shell, SWT.OPEN | SWT.SINGLE);
		dlg.setText("Select the X!Tandem software installation");
		String fileName = dlg.open();
		if (fileName != null) {
			conf.setXtandem_link(new File(fileName));
			if (conf.getXtandem_software_installed())
				t.setText(conf.getXtandem_link().getPath());
		}

	}

	public void save_configuration_to_disque() {
		try {
			conf.savePropertiestoXml();
		} catch (MSMSException e) {
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox
					.setMessage("Problems trying to save the configuration :\n"
							+ e.getMessage());
			messageBox.open();
		} catch (Exception e) {
			StackTraceElement[] f = e.getStackTrace();
			String error = e.getMessage() + "\nat : " + f[0].toString();
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox
					.setMessage("Problems trying to save the configuration :\n"
							+ error);
			messageBox.open();
			e.printStackTrace();
		}
	}

	public String get_folder_to(String title) {
		DirectoryDialog dlg2 = new DirectoryDialog(shell, SWT.SAVE | SWT.SINGLE);
		dlg2.setText("Defined prefered folder to " + title);
		// dlg2.setFilterPath(conf.getXmlresult().getAbsolutePath());
		String S_out = dlg2.open();
		return (S_out);
	}

	public void download_xtandem_software() {
		String u = "ftp://ftp.thegpm.org/projects/tandem/binary/";
		if (Desktop.isDesktopSupported()) {
			// On récupère l'instance du desktop :
			Desktop desktop = Desktop.getDesktop();
			if (desktop.isSupported(Desktop.Action.BROWSE)) {
				// Et on lance l'application associé au protocole :
				try {
					desktop.browse(new URI(u));
				} catch (Exception error) {
					error.printStackTrace();
				}
			}
		}

	}

}
