package test;

import java.util.Vector;

import org.apache.log4j.Logger;

import com.compomics.mascotdatfile.util.interfaces.Modification;
import com.compomics.mascotdatfile.util.mascot.MascotDatfile;
import com.compomics.mascotdatfile.util.mascot.Parameters;
import com.compomics.mascotdatfile.util.mascot.PeptideHit;
import com.compomics.mascotdatfile.util.mascot.ProteinHit;
import com.compomics.mascotdatfile.util.mascot.Query;
import com.compomics.mascotdatfile.util.mascot.QueryToPeptideMap;

import fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile.IdentificationDataFile;
import fr.inra.pappso.xtandempipeline.sax_parse.Mascot;

public class MascotTest {
	// Class specific log4j logger for TestMascotDatfile instances.
	private static Logger logger = Logger.getLogger(MascotTest.class);

	public static void main(String[] args) {
		 //String ds = "/tmp/FtoeoxSSO.dat";
		 String ds = "/tmp/F001323.dat";
		//String ds = "/media/E860-74C3/Triplex1_FT_light.dat";
		try {
			MascotDatfile mascot = new MascotDatfile(ds);
			logger.info("Read :" + mascot.getFileName());

			Parameters param = mascot.getParametersSection();
			System.out.println("Database : " + param.getDatabase());

			QueryToPeptideMap map = mascot.getQueryToPeptideMap();
			QueryToPeptideMap map2 = mascot.getDecoyQueryToPeptideMap();

			for (Object q : mascot.getQueryList()) {
				Query query = (Query) q;
				// System.out.println(query.getScans() + " | "
				// + query.getRetentionTimeInSeconds() + " | "
				// + query.getQueryNumber());
				Vector<?> peptides = map.getAllPeptideHits(query
						.getQueryNumber());
				if (peptides != null) {
					for (Object ob : peptides) {
						PeptideHit pep = (PeptideHit) ob;
						if (pep.getExpectancy() < 0.05) {
							System.out.println(query.getScans() + " | "
									+ query.getRetentionTimeInSeconds() + " | "
									+ query.getQueryNumber() + " | "
									+ query.getChargeString());
							System.out.println(pep.getModifiedSequence()
									+ " | " + pep.getIonsScore() + " | "
									+ pep.getHomologyThreshold());
							ProteinHit prot = (ProteinHit) pep.getProteinHits()
									.get(0);
							System.out
									.println(prot.getAccession()
											+ " | "
											+ prot.getStart()
											+ " | "
											+ prot.getStop()
											+ " | "
											+ prot.getPeptideStartInProtein_PeptideCentricDatabase()
											+ " | "
											+ prot.getPeptideStopInProtein_PeptideCentricDatabase());
							// for (Modification mod : pep.getModifications()) {
							// if (mod != null)
							// System.out.println(mod.getLocation() + " | "
							// + mod.getMass() + " | " + mod.getShortType());
							// }
							// System.out.println();
							// for(String i :
							// pep.getModifiedSequenceComponents()){
							// System.out.println(i);
							// }
						}
					}
				}
			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static double round(double what, int howmuch) {
		return (double) ((int) (what * Math.pow(10, howmuch) + .5))
				/ Math.pow(10, howmuch);
	}
}
