package fr.inra.pappso.xtandempipeline.filter_print;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MatchList;
import fr.inra.pappso.xtandempipeline.class_msms.MsRun;
import fr.inra.pappso.xtandempipeline.class_msms.MsRunSet;

public class filter_unique_peptide_number_to extends filter_base {

	private int peptide_number;

	public filter_unique_peptide_number_to(int pep_number) {
		super();
		this.peptide_number = pep_number;
		logger.info("Unvalidate match with less than "+pep_number+" peptide number in at leat one sample");
	}

	public int execute(MatchList m) throws MSMSException {
		// processing de la match_list
		for (Match ms : m.getMatchListes()) {
			MsRunSet samples = ms.get_sample_matchs();
			boolean valid = false;
			for(MsRun sample : samples){
				if (ms.get_unique_valid_peptide_number_to(sample) >= peptide_number)
					valid = true;
			}
			if (valid){
				numberOfValidMatch++;
			}else{
				ms.setIsvalidate(false);
			}
		}
		return (this.numberOfValidMatch);
	}


}
