package fr.inra.pappso.xtandempipeline.ui.results;

import fr.inra.pappso.xtandempipeline.MsException.StopException;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;
import fr.inra.pappso.xtandempipeline.ui.swt.Main_Windows;

import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.graphics.Point;


public class Peptide_Details extends window_base {

	public Peptide_Details(Main_Windows global) {
		super(global);
	}
	
	protected void move_CTabItem(CTabItem item, int index) {
		Peptide_Details_item newItem = new Peptide_Details_item(this, index);
		Peptide_Details_item dragitem = (Peptide_Details_item) item;
		newItem.setText(dragitem.getText());	
		dragitem.setControl(null);
		dragitem.dispose();
		folder.setSelection(newItem);
		if (dragitem.getPep() != null)	
			newItem.draw_spectra_to(dragitem.getPep(), false);
	}

	protected void view_CTab_Item_in_independant_windows(CTabItem dragItem,
			Point point) {
		Peptide_Details_item dragitem = (Peptide_Details_item) dragItem;
		Peptide_Details win = new Peptide_Details(controlleur);
		win.setLinked_to_main(false);
		win.set_menu_item(menuitem);
		win.open_windows();
		win.getShell().setSize(this.getShell().getSize());
		win.getShell().setLocation(point);
		if (dragitem.getPep() != null)
			win.draw_spectra_to(dragitem.getPep());
		dragItem.setControl(null);
		dragItem.dispose();
	}
	
	protected void initialise() {
		this.shell.setSize(600, 400);
	}
	
	protected void add_CTabItem() {
		int posi = folder.getItemCount()-1;
		posi = Math.max(0, posi);
		Peptide_Details_item item = new Peptide_Details_item(this,posi);
		item.setText("New Tab");
		folder.setSelection(item);
	}
	
	public void draw_spectra_to(Peptide pep) {
		try {
			if ((this.shell == null) || (this.shell.isDisposed())) {
				this.open_windows();
				// throw new StopException("");
				logger.debug("open shell");

			}
			
			if(folder.getSelection()==null)
				throw new StopException("");
			Peptide_Details_item item = (Peptide_Details_item) folder.getSelection();
			item.draw_spectra_to(pep,false);

		} catch (StopException e) {
			logger.debug("shell not open");
		} catch (Exception e) {
			this.view_error(e, "Problems with drawing spectra");
		}
	}

}
